# Monero Multisig Broker

A proof-of-concept broker for Monero multisig messages.

## Usage

### Build

```
$ make
```

### Run

```
$ ./mmb --management-credentials "admin:pass"
```

### Init multisig topic

The script uses hardcoded ("admin:pass" credentials), if you changed it, do the same in
`./utils/create_topic.sh`.

```
$ ./utils/create_topic.sh bob_buyer vendy_vendor
{
  "admin": {
    "host": "localhost:8080",
    "topic": "6b7d9e1e-17be-17af-cbfd-0277f5fce77e",
    "token": "2H1ke56p4LFoGvflS0"
  }
}
{
  "bob_buyer": {
    "host": "localhost:8080",
    "topic": "6b7d9e1e-17be-17af-cbfd-0277f5fce77e",
    "token": "1IXU5w4T2qYjtZ0z6K"
  }
}
{
  "vendy_vendor": {
    "host": "localhost:8080",
    "topic": "6b7d9e1e-17be-17af-cbfd-0277f5fce77e",
    "token": "u806D1df4TI2GxhNmc"
  }
}
```

### Push messages

Push message as `bob_buyer`.

```
$ ./utils/push_message.sh 6b7d9e1e-17be-17af-cbfd-0277f5fce77e 1IXU5w4T2qYjtZ0z6K
```

Push message as `vendy_vendor`.

```
$ ./utils/push_message.sh 6b7d9e1e-17be-17af-cbfd-0277f5fce77e u806D1df4TI2GxhNmc
```

### List messages

```
$ ./utils/list_messages.sh 6b7d9e1e-17be-17af-cbfd-0277f5fce77e u806D1df4TI2GxhNmc
[
  {
    "index": 0,
    "sender": "bob_buyer",
    "content_type": "application/json",
    "content": {
      "body": "hello world!"
    }
  },
  {
    "index": 1,
    "sender": "vendy_vendor",
    "content_type": "application/json",
    "content": {
      "body": "hello world!"
    }
  }
]
```
